open Mini_java

type symtab = Mini_java_symtab.t
type env = Mini_java_symtab.env

val is_subtype : symtab -> ty -> ty -> bool

(* The following functions raise a Mini_java_symtab.Type_error on type errors.
   The class_def parameter represents the enclosing class (needed for ensuring
   visibility rules. 
   The expr, stmt, fdecl, mdef, and class_def return values are necessary
   because expressions and statements have to be annotated with the
   static types of field access and method call receivers. *)

val tyof_expr : symtab -> class_def -> env -> expr -> (expr * ty)

val tycheck_stmt : symtab -> class_def -> env -> stmt -> stmt

val tycheck_fdecl : symtab -> class_def -> fdecl -> fdecl

val tycheck_mdef : symtab -> class_def -> mdef -> mdef

val tycheck_class : symtab -> class_def -> class_def

